import { Component, Host, h, Prop, Event, Method } from '@stencil/core';
import { CodeJar } from 'codejar';
import javascript from 'highlight.js/lib/languages/javascript';
import hljs from 'highlight.js/lib/core';
hljs.registerLanguage('javascript', javascript);
export class InlineEditor {
  constructor() {
    this.code = '';
  }
  /** This is a hack. I can't get the cursor to behave so I just exposed this. */
  async forceCodeChange(code) {
    var _a, _b, _c;
    (_a = this.jar) === null || _a === void 0 ? void 0 : _a.updateCode((this.code = code));
    // Pretty hacky, but this is the only way to position cursor at end.
    (_b = this.jar) === null || _b === void 0 ? void 0 : _b.restore({
      start: this.code.length,
      end: this.code.length,
      dir: '->',
    });
    (_c = this.editor) === null || _c === void 0 ? void 0 : _c.focus();
  }
  componentDidLoad() {
    this.jar = CodeJar(this.editor, (elem) => {
      elem.innerHTML = hljs.highlight(elem.textContent, {
        language: 'javascript',
      }).value;
    }, { tab: '  ' });
    this.jar.onUpdate(code => this.codeChanged.emit(code));
  }
  disconnectedCallback() {
    this.jar.destroy();
  }
  render() {
    return (h(Host, null,
      h("div", { class: "hljs editor monospace", ref: el => (this.editor = el) }, this.code)));
  }
  static get is() { return "inline-editor"; }
  static get originalStyleUrls() { return {
    "$": ["inline-editor.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["inline-editor.css"]
  }; }
  static get properties() { return {
    "code": {
      "type": "string",
      "mutable": true,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "code",
      "reflect": false,
      "defaultValue": "''"
    }
  }; }
  static get events() { return [{
      "method": "codeChanged",
      "name": "codeChanged",
      "bubbles": true,
      "cancelable": true,
      "composed": true,
      "docs": {
        "tags": [],
        "text": ""
      },
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      }
    }]; }
  static get methods() { return {
    "forceCodeChange": {
      "complexType": {
        "signature": "(code: string) => Promise<void>",
        "parameters": [{
            "tags": [],
            "text": ""
          }],
        "references": {
          "Promise": {
            "location": "global"
          }
        },
        "return": "Promise<void>"
      },
      "docs": {
        "text": "This is a hack. I can't get the cursor to behave so I just exposed this.",
        "tags": []
      }
    }
  }; }
}
