import { Component, Host, h, Prop } from '@stencil/core';
export class InlineRenderLogs {
  constructor() {
    this.logs = [];
  }
  render() {
    return (h(Host, null,
      h("div", { class: "logger monospace", ref: ref => (this.logger = ref) },
        !this.logs.length && (h("marquee", { scrollamount: "1" },
          h("div", { class: "log" }, "\uD83D\uDC22\uD83C\uDF88"))),
        this.logs.map(log => (h("div", { class: {
            log: true,
            trace: log.level === 'TRACE',
            info: log.level === 'INFO',
            warn: log.level === 'WARN',
            error: log.level === 'ERROR',
          } }, log.message.replaceAll('\\n', '\n').replaceAll('\\', '')))))));
  }
  static get is() { return "inline-render-logs"; }
  static get originalStyleUrls() { return {
    "$": ["inline-render-logs.scss"]
  }; }
  static get styleUrls() { return {
    "$": ["inline-render-logs.css"]
  }; }
  static get properties() { return {
    "logs": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "{ level: string; message: string }[]",
        "resolved": "{ level: string; message: string; }[]",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "defaultValue": "[]"
    }
  }; }
}
