export default class Logger {
  constructor(logCallback) {
    this.logCallback = logCallback;
    this.logs = [];
    this.trace = (...args) => this.logWithLevel('TRACE', ...args);
    this.log = (...args) => this.logWithLevel('INFO', ...args);
    this.info = (...args) => this.logWithLevel('INFO', ...args);
    this.warn = (...args) => this.logWithLevel('WARN', ...args);
    this.error = (...args) => this.logWithLevel('ERROR', ...args);
    this.clear = () => {
      this.logs = [];
      if (this.logCallback)
        this.logCallback(this.logs);
    };
  }
  logWithLevel(level, ...args) {
    const message = args.map(arg => (JSON.stringify(arg) || '').replace(/^"(.+)"$/g, '$1')).join(' ');
    this.logs = [...this.logs, { level, message }];
    if (this.logCallback)
      this.logCallback(this.logs);
  }
}
