import { Subject } from 'rxjs';
export default class Debugger {
  breaker: Subject<unknown>;
  panicker: Subject<unknown>;
  enabled: boolean;
  lastThrottle: Date;
  /**
   * Just like `this.wait(0)` but only triggers every @ms milliseconds so that
   * it will not become a bottleneck. Put in a tight loop to make sure that the
   * UI still breathes.
   */
  alive(ms?: number): Promise<void>;
  wait(options?: {
    ms?: number;
    preamble?: Function;
    callback?: Function;
  } | number | Function): Promise<void>;
  resume(): void;
  panic(): void;
  destroy(): void;
}
